// read analog sensor value from LDR/resistor voltage divider and
// send it out the serial port, toggle LED to indicate activity
// This program has a processing counterpart that reads the value transitted
// and sends it to a Patchube datastream
//
#define ldrPin 0	    // analog input pin where the LDR is attached
#define ledPin 13	    // digital output pin where the LED is attached

int 	ldrValue = 0;	    // raw value read from analog pin where LDR is attached
double	lastmillis = 0;	    // last time LDR value was communicated to the serial port

void setup() {
  pinMode(ledPin, OUTPUT);  // LED is output
  digitalWrite(ledPin, LOW);// initially LED is off
  Serial.begin(38400);      // setup serial communication speed
}

void loop()
{
  if ((millis() - lastmillis) > 1000) { // if time passed since last transmission is more than 1000ms
    ldrValue = analogRead(ldrPin);      // read value of LDR pin
    Serial.println(ldrValue);           // and ouput it to the serial port (in this case as
                                        // "readable text" followed by a newline
                                        // The counterpart in processing will have to deal with the
                                        // readable text format...

    // Toggle LED pin
    // You CAN actually read a pin setup as output
    // it will return the last value written to that pin
    // so to toggle it you write 0 if a 1 was read from the pin
    // and write 1 if a 0 was read from the pin
    if (digitalRead(ledPin))             // read pin value
      digitalWrite(ledPin, 0);          // write 0 if it was 1
    else
      digitalWrite(ledPin, 1);          // and 1 if it was 0
    lastmillis = millis();              // setup for next interval
  }
}
